/// <reference types="node" />
/// <reference types="node" />
import { CliServiceProvider } from '@mongosh/service-provider-server';
export interface BuildInfo {
    version: string;
    nodeVersion: string;
    distributionKind: 'unpackaged' | 'packaged' | 'compiled';
    runtimeArch: (typeof process)['arch'];
    runtimePlatform: (typeof process)['platform'];
    buildArch: (typeof process)['arch'];
    buildPlatform: (typeof process)['platform'];
    buildTarget: string;
    buildTime: string | null;
    gitVersion: string | null;
    opensslVersion: string;
    sharedOpenssl: boolean;
    segmentApiKey?: string;
    runtimeGlibcVersion: string;
    deps: ReturnType<typeof CliServiceProvider.getVersionInformation>;
}
export declare function baseBuildInfo(): Omit<BuildInfo, 'deps'>;
export declare function buildInfo({ withSegmentApiKey, }?: {
    withSegmentApiKey?: boolean;
}): Promise<BuildInfo>;
export declare function getGlibcVersion(): string | undefined;
