"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatForJSONOutput = void 0;
const util_1 = require("util");
const service_provider_core_1 = require("@mongosh/service-provider-core");
function formatForJSONOutput(value, mode) {
    if (util_1.types.isNativeError(value)) {
        value = {
            ...value,
            message: value.message,
            stack: value.stack,
            name: value.name,
        };
    }
    return service_provider_core_1.bson.EJSON.stringify(value, undefined, 2, {
        relaxed: mode === 'relaxed',
    });
}
exports.formatForJSONOutput = formatForJSONOutput;
//# sourceMappingURL=format-json.js.map