"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isFastFailureConnectionError = void 0;
function isFastFailureConnectionError(error) {
    switch (error.name) {
        case 'MongoNetworkError':
            return /\b(ECONNREFUSED|ENOTFOUND|ENETUNREACH|EINVAL)\b/.test(error.message);
        case 'MongoError':
            return /The apiVersion parameter is required/.test(error.message);
        default:
            return false;
    }
}
exports.isFastFailureConnectionError = isFastFailureConnectionError;
//# sourceMappingURL=fast-failure-connect.js.map