declare const SYSTEM_VARIABLES: readonly [{
    readonly name: "$$NOW";
    readonly value: "$$NOW";
    readonly score: 1;
    readonly meta: "variable:system";
    readonly version: "4.2.0";
    readonly description: "A variable that returns the current datetime value. NOW returns the same value for all members of the deployment and remains the same throughout all stages of the aggregation pipeline.";
}, {
    readonly name: "$$CLUSTER_TIME";
    readonly value: "$$CLUSTER_TIME";
    readonly score: 1;
    readonly meta: "variable:system";
    readonly version: "4.2.0";
    readonly description: "A variable that returns the current timestamp value. CLUSTER_TIME is only available on replica sets and sharded clusters. CLUSTER_TIME returns the same value for all members of the deployment and remains the same throughout all stages of the pipeline.";
}, {
    readonly name: "$$ROOT";
    readonly value: "$$ROOT";
    readonly score: 1;
    readonly meta: "variable:system";
    readonly version: "2.4.0";
    readonly description: "References the root document, i.e. the top-level document, currently being processed in the aggregation pipeline stage.";
}, {
    readonly name: "$$CURRENT";
    readonly value: "$$CURRENT";
    readonly score: 1;
    readonly meta: "variable:system";
    readonly version: "2.4.0";
    readonly description: "References the start of the field path being processed in the aggregation pipeline stage. Unless documented otherwise, all stages start with CURRENT the same as ROOT. CURRENT is modifiable. However, since `$<field>` is equivalent to `$$CURRENT.<field>`, rebinding CURRENT changes the meaning of `$` accesses.";
}, {
    readonly name: "$$REMOVE";
    readonly value: "$$REMOVE";
    readonly score: 1;
    readonly meta: "variable:system";
    readonly version: "3.6.0";
    readonly description: "A variable which evaluates to the missing value. Allows for the conditional exclusion of fields. In a `$project`, a field set to the variable REMOVE is excluded from the output.";
}, {
    readonly name: "$$DESCEND";
    readonly value: "$$DESCEND";
    readonly score: 1;
    readonly meta: "variable:system";
    readonly version: "3.0.0";
    readonly description: "One of the allowed results of a `$redact` expression.";
}, {
    readonly name: "$$PRUNE";
    readonly value: "$$PRUNE";
    readonly score: 1;
    readonly meta: "variable:system";
    readonly version: "3.0.0";
    readonly description: "One of the allowed results of a `$redact` expression.";
}, {
    readonly name: "$$KEEP";
    readonly value: "$$KEEP";
    readonly score: 1;
    readonly meta: "variable:system";
    readonly version: "3.0.0";
    readonly description: "One of the allowed results of a `$redact` expression.";
}, {
    readonly name: "$$SEARCH_META";
    readonly value: "$$SEARCH_META";
    readonly score: 1;
    readonly meta: "variable:system";
    readonly version: "5.0.0";
    readonly description: "A variable that stores the metadata results of an Atlas Search query. In all supported aggregation pipeline stages, a field set to the variable SEARCH_META returns the metadata results for the query. For an example of its usage, see Atlas Search facet and count.";
}, {
    readonly name: "$$USER_ROLES";
    readonly value: "$$USER_ROLES";
    readonly score: 1;
    readonly meta: "variable:system";
    readonly version: "7.0.0";
    readonly description: "A variable that stores the role names of the authenticated user running the command.";
}];
export { SYSTEM_VARIABLES };
//# sourceMappingURL=system-variables.d.ts.map