import type { CommandOperationOptions, Document, ObjectId, Sort } from 'mongodb';
export type FinalizeFunction<TKey = ObjectId, TValue = Document> = (key: TKey, reducedValue: TValue) => TValue;
export interface MapReduceOptions<TKey = ObjectId, TValue = Document> extends CommandOperationOptions {
    out?: 'inline' | {
        inline: 1;
    } | {
        replace: string;
    } | {
        merge: string;
    } | {
        reduce: string;
    };
    query?: Document;
    sort?: Sort;
    limit?: number;
    keeptemp?: boolean;
    finalize?: FinalizeFunction<TKey, TValue> | string;
    scope?: Document;
    jsMode?: boolean;
    verbose?: boolean;
    bypassDocumentValidation?: boolean;
}
