"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.textEncodingPolyfill = void 0;
if (typeof TextDecoder !== 'function' ||
    typeof TextEncoder !== 'function') {
    Object.assign(Function('return this')(), textEncodingPolyfill());
}
function textEncodingPolyfill() {
    class TextEncoder {
        encode(string) {
            return Buffer.from(string, 'utf8');
        }
    }
    class TextDecoder {
        decode(bytes) {
            const str = Buffer.from(bytes).toString('utf8');
            return str.slice(+str.startsWith('\ufeff'));
        }
    }
    return { TextDecoder, TextEncoder };
}
exports.textEncodingPolyfill = textEncodingPolyfill;
//# sourceMappingURL=textencoder-polyfill.js.map